/********************************************************************
 * Copyright (C) 2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : BTTcpSocket.cpp
 * DATE   : 27.06.2007
 *******************************************************************/
#ifndef INCLUDED_BTTcpSocket_h
#define INCLUDED_BTTcpSocket_h

/*------- include files:
-------------------------------------------------------------------*/
#include <BTSocket.h>
#include <string>

/*------- class declaration:
-------------------------------------------------------------------*/
class BTTcpSocket : public BTSocket, public BTSocketInterface
{
// ******* CONSTRUCTION / DESTRUCTION *******
public:
   BTTcpSocket( const std::string&, int, Type = CLIENT );
   BTTcpSocket( int );
   BTTcpSocket( const BTTcpSocket& rhs ) : BTSocket( rhs ), BTSocketInterface( rhs ) {
      addr_ = rhs.addr_;
      port_ = rhs.port_;
      type_ = rhs.type_;
   }
   BTTcpSocket& operator=( const BTTcpSocket& rhs ) {
      BTSocket::operator=( rhs );
      BTSocketInterface::operator=( rhs );
      addr_ = rhs.addr_;
      port_ = rhs.port_;
      type_ = rhs.type_;
   }

// ******* MEMBERS *******
private:
   std::string addr_;
   int         port_;
   Type        type_;

// ******* METHODS *******
public:
   void bind      ();
   void connect   ();
   int  accept    ();
};

#endif // INCLUDED_BTTcpSocket_h
