/********************************************************************
 * Copyright (C) 2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : BTThread.cpp
 * DATE   : 27.06.2007
 *******************************************************************/
#ifndef INCLUDED_BTThread_h
#define INCLUDED_BTThread_h

/*------- include files:
-------------------------------------------------------------------*/
#include <pthread.h>

/*------- class declaration:
-------------------------------------------------------------------*/
class BTThread
{
// ******* CONSTRUCTION / DESTRUCTION *******
public:
   BTThread();
   virtual ~BTThread();
private:
   BTThread( const BTThread& );
   BTThread& operator=( const BTThread& );

// ******* MEMBERS *******
private:
   bool      started_;
   pthread_t id_;
   

// ******* METHODS *******
public:
   bool         start     ();
   void         join      ();
   void         cancel    ();
   bool         is_started() const { return started_; }
protected:
   virtual void worker() = 0;
   void         test_cancel() { pthread_testcancel(); }
private:
   static void* do_it     ( void* );
};

#endif // INCLUDED_BTThread_h
