/********************************************************************
 * Copyright (C) 2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : BTUnixSocket.cpp
 * DATE   : 27.06.2007
 *******************************************************************/
#ifndef INCLUDED_BTUnixSocket_h
#define INCLUDED_BTUnixSocket_h

/*------- include files:
-------------------------------------------------------------------*/
#include <BTSocket.h>
#include <string>

/*------- class declaration:
-------------------------------------------------------------------*/
class BTUnixSocket : public BTSocket, public BTSocketInterface
{
// ******* CONSTRUCTION / DESTRUCTION *******
public:
   BTUnixSocket( const std::string&, Type = CLIENT );
   BTUnixSocket( int );
   BTUnixSocket( const BTUnixSocket& rhs ) : BTSocket( rhs ), BTSocketInterface( rhs ) {
      type_ = rhs.type_;
      path_ = rhs.path_;
   }
   BTUnixSocket& operator=( const BTUnixSocket& rhs ) {
      if( this != &rhs ) {
         BTSocket::operator=( rhs );
         BTSocketInterface::operator=( rhs );
         type_ = rhs.type_;
         path_ = rhs.path_;
      }
      return *this;
   }
   
// ******* MEMBERS *******
private:
   Type        type_;
   std::string path_;

// ******* METHODS *******
public:
   Type               type () const { return type_; }
   const std::string& path () const { return path_; }
   
   void bind    ();
   void connect ();
   int  accept  ();
};

#endif // INCLUDED_BTUnixSocket_h
