/********************************************************************
 * Copyright (C) 2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : TcpListener.cpp
 * DATE   : 27.06.2007
 *******************************************************************/
#ifndef INCLUDED_TcpListener_h
#define INCLUDED_TcpListener_h

/*------- include files:
-------------------------------------------------------------------*/
#include <BTThread.h>
#include <BTTcpSocket.h>

/*------- class declaration:
-------------------------------------------------------------------*/
class TcpListener : public BTThread
{
// ******* CONSTANTS *******
private:
   static const int         DEFAULT_PORT;

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   TcpListener( int = DEFAULT_PORT );
private:
   TcpListener( const TcpListener& );
   TcpListener& operator=( const TcpListener& );

// ******* MEMBERS *******
private:
   BTTcpSocket socket_;

// ******* METHODS *******
private:
   void worker();
   void send_data  ( int );
   bool send_scopes( BTTcpSocket& );
   void send_msg   ( BTTcpSocket& );
   bool send_next  ( int ) const;
};

#endif // INCLUDED_TcpListener_h
