/********************************************************************
 * Copyright (C) 2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cobras; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : TraceServer.cpp
 * DATE   : 27.06.2007
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include <BTCallArgs.h>
#include "UxListener.h"
#include "TcpListener.h"
#include <iostream>
using namespace std;

//*******************************************************************
// display_help
//*******************************************************************
void display_help()
{
   cout << endl << "Trace Server is part of Beesoft Tracer" << endl << endl;

   cout << "Using:" << endl;
   cout << "\ttracesrv [-port <port_number>]" << endl<< endl;
   cout << "where <port_number> is a port on which server waits for connection with client." << endl;
   cout << "Without parametrs server waits for connection on port 6789." << endl;
   cout << "For help (this text) type 'tracesrv' width --help or -h." << endl;

   cout << endl;
}
// end of display_help

//*******************************************************************
// main
//*******************************************************************
int main( const int n, const char** const args )
{
   BTCallArgs pars( n, args );

   if( pars.need_help() ) {
      display_help();
   }
   else if( pars.port_is_valid() ) {
      UxListener  ux_listener;
      TcpListener tcp_listener( pars.port() );
      
      ux_listener.start();
      tcp_listener.start();
      
      ux_listener.join();
      tcp_listener.join();
   }
   
   return 0;
}
// end of main
