/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : MessageBase.h
 * DATE   : 01.07.2007
 *******************************************************************/
#ifndef INCLUDED_MessageBase_h
#define INCLUDED_MessageBase_h

/*------- include files:
-------------------------------------------------------------------*/
#include "Message.h"
#include <QObject>
#include <BTMutex.h>
#include <BTCondWait.h>
#include <queue>

/*------- class declaration:
-------------------------------------------------------------------*/
class MessageBase : public QObject
{
// ******* CONSTRUCTION / DESTRUCTION *******
private:
   MessageBase();
   MessageBase( const MessageBase& );
   MessageBase& operator=( const MessageBase& );
public:
   ~MessageBase();
// ******* MEMBERS *******
private:
   static MessageBase* instance_;
   bool                is_running_;
   BTMutex             mutex_;
   BTCondWait          not_empty_;
   std::queue<Message> data_;
   
// ******* METHODS ********
public:
   static MessageBase* const instance();
   void add  ( const Message& );
   bool get  ( Message& );
   void stop ();
};

#endif // INCLUDED_MessageBase_h
