/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : Network.h
 * DATE   : 01.07.2007
 *******************************************************************/
#ifndef INCLUDED_Network_h
#define INCLUDED_Network_h

/*------- include files:
-------------------------------------------------------------------*/
#include <BTThread.h>
#include <BTTcpSocket.h>
#include <string>


/*------- class declaration:
-------------------------------------------------------------------*/
class Network : public BTThread
{
// ******* CONSTRUCTION / DESTRUCTION *******
public:
   Network();
   ~Network();
private:
   Network( const Network& );
   Network& operator=( const Network& );
   
// ******* MEMBERS *******
private:
   std::string  addr_;
   int          port_;
   BTTcpSocket* socket_;
   bool         is_running_;

// ******* METHODS *******
public:
   void connect_host( const std::string&, int );
   void disconnect  ();
private:
   void worker      ();
   bool read_message();
   bool read_next   ( int ) const;
   void clean_up    ();
};

#endif // INCLUDED_Network_h
