/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : Scopes.h
 * DATE   : 01.07.2007
 *******************************************************************/
#ifndef INCLUDED_Scopes_h
#define INCLUDED_Scopes_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QObject>
#include <BTMutex.h>
#include <ScopeDefs.h>
#include <set>
#include <string>


/*------- class declaration:
-------------------------------------------------------------------*/
class Scopes : public QObject
{
// ******* CONSTRUCTION / DESTRUCTION *******
private:
   Scopes();
   Scopes( const Scopes& );
   Scopes& operator=( const Scopes& );
public:
   ~Scopes();
// ******* MEMBERS *******
private:
   static Scopes* instance_;
   BTMutex        mutex_;
   InvScopeDefs   scopes_;
   std::set<int>  selected_;

 // ******* METHOD *******
public:
   static Scopes* const instance();

   void selected( const std::set<int>& in_selected ) { selected_ = in_selected; }
   void add  ( int, const std::string& );
   bool find ( int, std::string&, std::string& );
   bool first( int&, ScopeInfo& );
   bool next ( int&, ScopeInfo& );
};

#endif // INCLUDED_Scopes_h
