/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : ServerEdit.h
 * DATE   : 02.07.2007
 *******************************************************************/
#ifndef INCLUDED_ServerEdit_h
#define INCLUDED_ServerEdit_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QDialog>

/*------- forward declaration:
-------------------------------------------------------------------*/
class QLineEdit;

/*------- class declaration:
-------------------------------------------------------------------*/
class ServerEdit : public QDialog
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   ServerEdit( QWidget*, const QString&, const QString&, const QString& );
private:
   ServerEdit( const ServerEdit& );
   ServerEdit& operator=( const ServerEdit& );

// ******* CONSTANTS *******
private:
   static const char* const TITLE;
   static const char* const NAME_LABEL;
   static const char* const ADDR_LABEL;
   static const char* const PORT_LABEL;
   static const char* const CANCEL_LABEL;
   static const char* const ACCEPT_LABEL;
   static const char* const BOX_TITLE;
   
// ******* MEMBERS *******
private:
   QLineEdit* const name_edt_;
   QLineEdit* const addr_edt_;
   QLineEdit* const port_edt_;

// ******* METHODS *******
public:
   void data( QString&, QString&, QString& );
private slots:
   void ok();
};

#endif // INCLUDED_ServerEdit_h
