/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : ServerDialog.h
 * DATE   : 02.07.2007
 *******************************************************************/
#ifndef INCLUDED_ServersDialog_h
#define INCLUDED_ServersDialog_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QDialog>

/*------- forward declarations:
-------------------------------------------------------------------*/
class ServersTable;

/*------- class declaration:
-------------------------------------------------------------------*/
class ServersDialog : public QDialog
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   ServersDialog( QWidget* );
private:
   ServersDialog( const ServersDialog& );
   ServersDialog& operator=( const ServersDialog& );

// ******* CONSTANTS *******
private:
   static const char* const TITLE;
   static const char* const ADD_BTN_LABEL;
   static const char* const EDIT_BTN_LABEL;
   static const char* const DEL_BTN_LABEL;
   static const char* const CANCEL_BTN_LABEL;
   static const char* const OK_BTN_LABEL;
   static const char* const SRV_NAME_DEFAULT;
   static const char* const SRV_ADDR_DEFAULT;
   static const char* const SRV_PORT_DEFAULT;

// ******* MEMBERS *******
private:
   ServersTable* const table_;

// ******* METHODS *******
private:
   void   save_data();
   void   restore_data();
private slots:
   void   add();
   void   edit();
   void   del();
   void   ok();
};

#endif // INCLUDED_ServersDialog_h
