/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : ServersTable.h
 * DATE   : 02.07.2007
 *******************************************************************/
#ifndef INCLUDED_ServersTable_h
#define INCLUDED_ServersTable_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QTableWidget>

/*------- class declaration:
-------------------------------------------------------------------*/
class ServersTable : public QTableWidget
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   ServersTable( QWidget* = 0 );
private:
   ServersTable( const ServersTable& );
   ServersTable& operator=( const ServersTable& );

// ******* CONSTANTS *****
private:
   static const char* const NAME;
   static const char* const ADDR;
   static const char* const PORT;

 // ******* METHODS *******
public:
   void   add_data           ( const QString&, const QString&, const QString& );
   void   set_data           ( qint32, const QString&, const QString&, const QString& );
   qint32 search_item        ( const QString&, const QString&, const QString& );
   void   set_current_item   ( qint32 );
private:
   void   resizeEvent        ( QResizeEvent* );
   void   resize_columns     ();
   qint32 total_columns_width() const;
};

#endif // INCLUDED_ServersTable_h
