/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : Settings.h
 * DATE   : 20.09.2006
 *******************************************************************/
#ifndef INCLUDED_Settings_H
#define INCLUDED_Settings_H

/*------- include files:
-------------------------------------------------------------------*/
#include <QObject>
#include <QSettings>
#include <QVariant>

/*------- class declaration:
-------------------------------------------------------------------*/
class Settings : protected QSettings
{
   Q_OBJECT
// ******* CONSTRUCTION / DESTRUCTION *******
public:
   Settings() : QSettings() {}
private:
   Settings( const Settings& );
   Settings& operator=( const Settings& );
public:   
   bool save  ( const QString&, const QVariant& );
   bool read  ( const QString&, QVariant& );
};

#endif // INCLUDED_Settings_H
