/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : Shared.h
 * DATE   : 29.06.2007
 *******************************************************************/
#ifndef INCLUDED_Shared_h
#define INCLUDED_Shared_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QObject>
#include <QString>

/*------- class declaration:
-------------------------------------------------------------------*/
class Shared : public QObject
{
// ******* CONSTRUCTION / DESTRUCTION *******
private:
   Shared( const Shared& );
   Shared& operator=( const Shared& );

// ******* CONSTANTS *******
private:
   static const char* const ORGANISATION;
   static const char* const VERSION;
   static const char* const PROGRAM_NAME;
   static const char* const PROGRAM_SUBNAME;
   static const char* const DEFAULT_SRV_NAME;
   static const char* const DEFAULT_SRV_ADDR;
   static qint32            DEFAULT_SRV_PORT;

// ******* MEMBERS *******
private:
   static QString buffer_;
   static QString srv_name_;
   static QString srv_addr_;
   static QString srv_port_;

// ******* METHODS *******
public:
   static const QString& full_program_name ();
   static const QString& program_name      ();
   static const QString& organisation      ();
   static const QString  default_srv_name  ();
   static const QString  default_srv_addr  ();
   static qint32         default_srv_port  ();
   static const QString& srv_name          ();
   static const QString& srv_addr          ();
   static const QString& srv_port          ();
   static void           srv_name          ( const QString& );
   static void           srv_addr          ( const QString& );
   static void           srv_port          ( const QString& );
   static void           resize            ( QWidget*, qint32, qint32 );
   static void           idle              ();

};

#endif // INCLUDED_Shared_h
