/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : Table.h
 * DATE   : 29.06.2007
 *******************************************************************/
#ifndef INCLUDED_Table_h
#define INCLUDED_Table_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QTableWidget>
#include <BTMutex.h>
#include "Event.h"


/*------- class declaration:
-------------------------------------------------------------------*/
class Table : public QTableWidget
{
   Q_OBJECT

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   Table( QWidget* = 0 );
private:
   Table( const Table& );
   Table& operator=( const Table& );

// ******* MEMBERS *****
private:
   const QPixmap icon_in_;
   const QPixmap icon_out_;
   const QPixmap icon_info_;
   const QPixmap icon_warn_;
   const QPixmap icon_err_;
   qint32 x_width_;
   qint32 x_height_;
   BTMutex mutex_;

// ******* METHODS *******
private:
   void   display            ( Event* );
   void   add                ( qint32, const QString&, const QString&, const QString& );
   void   customEvent        ( QEvent* );
   void   resizeEvent        ( QResizeEvent* );
   void   resize_columns     ();
   qint32 total_columns_width() const;
};

#endif // INCLUDED_Table_h
