/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : TraceView.cpp
 * DATE   : 29.06.2007
 *******************************************************************/

/*------- include files:
-------------------------------------------------------------------*/
#include "MainWindow.h"
#include "Shared.h";
#include "Scopes.h"
#include "MessageBase.h"
#include <QIcon>
#include <QApplication>


//*******************************************************************
// main
//*******************************************************************
int main( int in_argc, char** in_argv )
{
   Q_INIT_RESOURCE( TraceView );

   QCoreApplication::setOrganizationName  ( Shared::organisation() );
   QCoreApplication::setOrganizationDomain( Shared::organisation() );
   QCoreApplication::setApplicationName   ( Shared::program_name() );
   
   QApplication app( in_argc, in_argv );
   Scopes::instance();
   MessageBase::instance();

   app.setWindowIcon( QIcon( ":/img/TraceView.png" ) );
   MainWindow main_window;
   main_window.show();
   const int retval = app.exec();

   return retval;
}
// end of main
