/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : Tree.h
 * DATE   : 29.06.2007
 *******************************************************************/
#ifndef INCLUDED_Tree_h
#define INCLUDED_Tree_h

/*------- include files:
-------------------------------------------------------------------*/
#include <Qt>
#include <QTreeWidget>

/*------- forward declarations:
-------------------------------------------------------------------*/
class TreeItem;

/*------- class declaration:
-------------------------------------------------------------------*/
class Tree : public QTreeWidget
{
   Q_OBJECT

// ******* TYPES *******
private:
   enum {
      UNKNOWN = 0,
      CLASS,
      METHOD,

      TYPE = Qt::UserRole + 1,
      ID,
   };

// ******* CONSTRUCTION / DESTRUCTION *******
public:
   Tree( QWidget* = 0 );
   ~Tree();
private:
   Tree( const Tree& );
   Tree& operator=( const Tree& );

// ******* MEMBERS *******
private:
   bool check_state_;

// ******* METHODS *******
private:
   void            customEvent        ( QEvent* );
   TreeItem* const add_class          ( const QString&  );
   TreeItem* const search_class       ( const QString&  ) const;
   Qt::CheckState  check_class_state  ( const TreeItem* ) const;
   void            set_scopes         ();
   void            get_selected_scopes();
   void            add                ( qint32, const QString&, const QString& );
private slots:
   void item_changed( QTreeWidgetItem* );
};

#endif // INCLUDED_Tree_h
