/********************************************************************
 * Copyright (C) 2006-2007 Piotr Pszczolkowski
 *-------------------------------------------------------------------
 * This file is part of Beesoft Tracer.
 *
 * Beesoft Tracer is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Beesoft Tracer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Beesoft Tracer; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *-------------------------------------------------------------------
 * AUTHOR : Piotr Pszczolkowski (piotr@beesoft.org)
 * PROJECT: Beesoft Tracer
 * FILE   : Tree.h
 * DATE   : 29.06.2007
 *******************************************************************/
#ifndef INCLUDED_TreeItem_h
#define INCLUDED_TreeItem_h

/*------- include files:
-------------------------------------------------------------------*/
#include <QTreeWidgetItem>

/*------- forward declarations:
-------------------------------------------------------------------*/
class Tree;

/*------- class declaration:
-------------------------------------------------------------------*/
class TreeItem : public QTreeWidgetItem
{
// ******* CONSTRUCTION / DESTRUCTION *******
public:
   TreeItem();
   TreeItem( Tree* );
   TreeItem( QTreeWidgetItem* );
private:
   TreeItem( const TreeItem& );
   TreeItem& operator=( const TreeItem& );

// ****** METHODS *******
public:
   Qt::CheckState status() const { return checkState( 0 ); }
   void   status( const Qt::CheckState in_state ) { setCheckState( 0, in_state ); }
};

#endif // INCLUDED_TreeItem_h
